/*check the matrix*/
/*last modified: apr 14, 2013*/
/*author: Chen, Xiaoming*/

#include "nicslu.h"
#include "nicslu_internal.h"

int__t _I_NicsLU_Check(SNicsLU *nicslu)
{
	int__t rt;
	uint__t p1, p2, p;
	uint__t i, j, n;
	int__t jlast;
	uint__t *ai, *ap;

	if (NULL == nicslu)
	{
		return NICSLU_ARGUMENT_ERROR;
	}
	if (!nicslu->flag[0])
	{
		return NICSLU_MATRIX_NOT_INITIALIZED;
	}

	rt = NICS_OK;
	n = nicslu->n;
	ai = nicslu->ai;
	ap = nicslu->ap;

	for (i=0; i<n; ++i)
	{
		p1 = ap[i];
		p2 = ap[i+1];
		if (p1 > p2)
		{
			return NICSLU_MATRIX_INVALID;
		}
		jlast = -1;
		for (p=p1; p<p2; ++p)
		{
			j = ai[p];
			if ((uint__t)j >= n)
			{
				return NICSLU_MATRIX_INVALID;
			}
			if (j == jlast)
			{
				return NICSLU_MATRIX_ENTRY_DUPLICATED;
			}
			if (j < (uint__t)jlast)
			{
				rt = NICSLU_MATRIX_NOT_SORTED;
			}
			jlast = j;
		}
	}

	return rt;
}
