
#include "kat.h"
#include "kat_knm_mirror.h"
#include "kat_io.h"

#ifndef KAT_KNM_INT_H
#define	KAT_KNM_INT_H

// Default settings for interpolation routines
#define DEFAULT_INTERP_SIZE 3;   // must be odd integer > 3
#define DEFAULT_INTERP_METHOD 3; // 1 - spline, 2 - linear, 3 -NN, Nearest Neighbour

//here we define a macro that applies a round off to zero if the number is smaller than the error
//#define INT_VAL(u) ((abs(error[u]*1e-1) < abs(integral[u])) ? integral[u] : 0) * J
#define INT_VAL(u) integral[u] * J

void interpolate_merged_map(surface_merged_map_t *map, KNM_COMPONENT_t knmcmp, int knum, const double px
        , const double py, double *const A, double *const phi, double nr1
        , double nr2, double angle);

void do_para_cuhre_map_int(void *p, KNM_COMPONENT_t knmcmp, complex_t *results);

void do_riemann_sum_new_int(void *userdata, KNM_COMPONENT_t knmcmp, complex_t *results);

void do_serial_cuhre_map_int(void *p, KNM_COMPONENT_t knmcmp, complex_t *results);

void gsl_map_interpol_free_mm(surface_merged_map_t *map);
void gsl_map_interpol_free(surface_map_t *map);
void gsl_map_interpol_init_mm(surface_merged_map_t *map);
void gsl_map_interpol_init(surface_map_t *map);

#endif	/* KAT_KNM_INT_H */

